### Class

# Shumate DataSource

#### Description [src]

    abstract class Shumate.DataSource : GObject.Object {
      parent_instance: GObject
    }

The base class used to retrieve tiles as `GBytes`.

#### Ancestors

- GObject

#### Descendants

- ShumateTileDownloader

#### Instance methods

###### shumate_data_source_get_tile_data_async

Gets the data for the tile at the given coordinates.

###### shumate_data_source_get_tile_data_finish

Gets the final result of a request started with shumate_data_source_get_tile_data_async().

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Signals

###### Shumate.DataSource::received-data

Emitted when data is received for any tile. This includes any intermediate steps, such as data from the file cache, as well as the final result.

##### Signals inherited from GObject (1)

###### GObject.Object::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct ShumateDataSourceClass {
      GObjectClass parent_class;
      void (* get_tile_data_async) (
        ShumateDataSource* self,
        int x,
        int y,
        int zoom_level,
        GCancellable* cancellable,
        GAsyncReadyCallback callback,
        gpointer user_data
      );
      GBytes* (* get_tile_data_finish) (
        ShumateDataSource* self,
        GAsyncResult* result,
        GError** error
      );

    }

###### Class members

`parent_class`

    GObjectClass

| No description available.

`get_tile_data_async`

    void (* get_tile_data_async) (
        ShumateDataSource* self,
        int x,
        int y,
        int zoom_level,
        GCancellable* cancellable,
        GAsyncReadyCallback callback,
        gpointer user_data
      )

| No description available.

`get_tile_data_finish`

    GBytes* (* get_tile_data_finish) (
        ShumateDataSource* self,
        GAsyncResult* result,
        GError** error
      )

| No description available.

#### Virtual methods

###### Shumate.DataSourceClass.get_tile_data_async

Gets the data for the tile at the given coordinates.

###### Shumate.DataSourceClass.get_tile_data_finish

Gets the final result of a request started with shumate_data_source_get_tile_data_async().